<template>
  <v-app>
    <v-navigation-drawer
      persistent
      :mini-variant="miniDrawer"
      v-model="showDrawer"
      fixed
      app
    >
      <v-layout column fill-height>
        <v-list>
          <v-subheader v-show="!miniDrawer">Main menu</v-subheader>
          <v-subheader v-show="miniDrawer"
            ><v-icon>mdi-menu-down</v-icon></v-subheader
          >
          <v-list-item to="/home">
            <v-list-item-action>
              <v-icon>web</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title>Home</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
          <v-list-item to="/ontologies">
            <v-list-item-action>
              <v-icon>mdi-graph</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title>Ontologies</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
          <v-list-item to="/search">
            <v-list-item-action>
              <v-icon>mdi-feature-search</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title>Search</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
          <v-list-item to="/wordcloud">
            <v-list-item-action>
              <v-icon>mdi-chart-scatter-plot</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title>Word Cloud</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>
        <v-divider></v-divider>
        <v-spacer></v-spacer>
        <v-list>
          <v-list-item @click="switchMiniDrawer">
            <v-list-item-action>
              <v-icon v-if="miniDrawer">chevron_right</v-icon>
              <v-icon v-else>chevron_left</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title>Collapse</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </v-layout>
    </v-navigation-drawer>
    <v-app-bar
      :dark="!$vuetify.theme.dark"
      :color="!$vuetify.theme.dark ? 'primary' : ''"
      app
    >
      <v-app-bar-nav-icon @click.stop="switchShowDrawer"></v-app-bar-nav-icon>
      <v-toolbar-title>ForWoT</v-toolbar-title>
      <v-spacer></v-spacer>
      <v-switch
        v-model="$vuetify.theme.dark"
        @change="switchTheme"
        :dark="!$vuetify.theme.dark"
        append-icon="palette"
        hide-details
      />
    </v-app-bar>
    <v-main>
      <router-view />
    </v-main>
    <v-footer class="pa-6 flex justify-space-between" fixed app>
      <div class="align-center" style="display: flex; flex: 1">
        <img
          :src="eu"
          style="max-height: 40px; margin-right: 10px; margin-left: 20px"
          alt="EU Logo"
        />
        <div style="overflow-wrap: anywhere; text-align: justify-all">
          This project has received funding from the European Union’s Horizon
          2020 research and innovation <br />
          programme within the framework of the AI4EU Project funded under grant
          agreement No 825619
          <!--     -->
        </div>
        <img :src="ai4eu" style="max-height: 40px" alt="EU Logo" />
      </div>
      <div>&copy; {{ new Date().getFullYear() }} thingenious.io</div>
    </v-footer>
    <NotificationsManager />
  </v-app>
</template>

<script lang="ts">
import Vue from "vue";
import NotificationsManager from "@/components/NotificationsManager.vue";
import {
  readDashboardMiniDrawer,
  readDashboardShowDrawer,
  readDomains,
} from "@/store/main/getters";
import {
  commitSetDashboardMiniDrawer,
  commitSetDashboardShowDrawer,
} from "@/store/main/mutations";
import { dispatchGetDomains } from "@/store/main/actions";

export default Vue.extend({
  name: "App",

  data: () => {
    return {
      eu: require("./assets/eu.svg"),
      ai4eu: require("./assets/ai4eu.svg"),
    };
  },
  components: {
    NotificationsManager,
  },
  mounted() {
    if (readDomains(this.$store) == null) {
      dispatchGetDomains(this.$store);
    }
  },
  computed: {
    showDrawer: {
      get: function () {
        return readDashboardShowDrawer(this.$store);
      },
      set: function (value: boolean) {
        commitSetDashboardShowDrawer(this.$store, value);
      },
    },
    miniDrawer: function () {
      return readDashboardMiniDrawer(this.$store);
    },
  },
  methods: {
    switchTheme() {
      window.localStorage.setItem(
        "theme",
        this.$vuetify.theme.dark ? "dark" : "light"
      );
    },

    switchShowDrawer: function () {
      commitSetDashboardShowDrawer(
        this.$store,
        !readDashboardShowDrawer(this.$store)
      );
    },
    switchMiniDrawer: function () {
      commitSetDashboardMiniDrawer(
        this.$store,
        !readDashboardMiniDrawer(this.$store)
      );
    },
  },
});
</script>
